<template>
    <div class='mx-6 sm:mx-14'>
        <p class='text-4xl sm:text-5xl font-bold text-xmas-gray sm:text-center'>Данни за доставка</p>
        <p class='text-sm mt-10'>
            Супер! Ще инструктираме твоят таен Дядо Коледа да изпрати подаръците ти 
            <template v-if="isHome">до твоя адрес!</template>
            <template v-if="isForStudio">до нашето студио!</template>
            <template v-if="isOffice">до най-удобния за теб офис на {{ $store.getters['register/courierName'] }}!</template>
        </p>
        <template v-if='! isForStudio'>
            <p class='text-sm mt-4'>
                <template v-if="isHome">Сега само ще трябва да ни кажеш къде точно искаш да дойде джуджето на {{ $store.getters['register/courierName'] }}.</template>
                <template v-else>Сега само ще трябва да ни кажеш кой е той.</template>
            </p>
            <div class='mt-10 mb-10 space-y-3'>
                <Text v-if='isOffice' v-model="form.office" @blur="v$.form.office.$touch()" :invalid="v$.form.office.$error" :label="courierLabel" required></Text>
                <Text v-if='isHome' v-model="form.address" @blur="v$.form.address.$touch()" :invalid="v$.form.address.$error" label="Адрес" required></Text>
                <Text v-model="form.city" @blur="v$.form.city.$touch()" :invalid="v$.form.city.$error" label="Град" required></Text>
                <Text v-model="form.phone" @blur="v$.form.phone.$touch()" :invalid="v$.form.phone.$error" label="Телефон" number required></Text>
            </div>
        </template>
        <ButtonStack :disabled="v$.$invalid || v$.$pending" @click='advance' label="Напред"></ButtonStack>
    </div>
</template>

<script>
    import Text from '@/components/Text'
    import ButtonStack from '@/components/ButtonStack'
    import useVuelidate from '@vuelidate/core' 
    import { helpers, required, email, minLength, maxLength, requiredIf } from '@vuelidate/validators'

    const validPhone = (value) => value == '' || value.startsWith(0)
   
    export default {
        name: 'Step 5',
        components: {
            Text,
            ButtonStack
        },
        data() {
            return {
                form: {
                    office: '',
                    address: '',
                    phone: '',
                    city: '',
                }, 
                v$: useVuelidate(),
            }
        },
        methods: {  
            forward() {
                this.$store.commit('stepForward');
            },
            advance() {
                this.syncWithStore();
                this.$store.dispatch("register/advance")
            },
            syncWithStore() {
                this.$store.state.register.registrationData.office = this.form.office;
                this.$store.state.register.registrationData.address = this.form.address;
                this.$store.state.register.registrationData.phone = this.form.phone;
                this.$store.state.register.registrationData.city = this.form.city;
            },
            syncFromStore() {
                this.form.office = this.$store.state.register.registrationData.office;
                this.form.address = this.$store.state.register.registrationData.address;
                this.form.phone = this.$store.state.register.registrationData.phone;
                this.form.city = this.$store.state.register.registrationData.city;
            },
        },
        created() {
            this.syncFromStore();
        },
        computed: {
            isHome() {
                return this.$store.getters['register/isHome'];
            },
            isOffice() {
                return this.$store.getters['register/isOffice'];
            },
            isForStudio() {
                return this.$store.getters['register/isForStudio'];
            },
            courierLabel() {
                return 'Офис на ' + this.$store.getters['register/courierName'];
            }
        },
        validations: {
            form: {
                office: {
                    requiredIf: requiredIf(function() { return this.isOffice }),
                    minLength: minLength(4),
                },
                address: {
                    requiredIf: requiredIf(function() { return this.isHome }),
                    minLength: minLength(6),
                },
                phone: {
                    requiredIf: requiredIf(function() { return this.isHome || this.isOffice }),
                    valid: validPhone,
                    minLength: minLength(10),
                    maxLength: maxLength(10),
                },
                city: {
                    requiredIf: requiredIf(function() { return this.isHome || this.isOffice }),
                }
            }
        }
    }
</script>